package com.domemusictechnologies.forthphase;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here
//[/user-imports]


public class ForthPhase extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public ForthPhase( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "Forth Phase", ModuleType.ModuleType_Filters, 1.0 );

   InitializeControls();


   canBeBypassed = true;
   SetSkin( "94ceeb3cc2f14452a6993dd4f3c9dd98" );
}

void InitializeControls()
{

   inputAudio = new VoltageAudioJack( "Audio Input", "Audio Input", this, JackType.JackType_AudioInput );
   AddComponent( inputAudio );
   inputAudio.SetWantsMouseNotifications( false );
   inputAudio.SetPosition( 24, 53 );
   inputAudio.SetSize( 25, 25 );
   inputAudio.SetSkin( "Jack Round Cherry Ring" );

   inputCV = new VoltageAudioJack( "CV Input", "CV Input", this, JackType.JackType_AudioInput );
   AddComponent( inputCV );
   inputCV.SetWantsMouseNotifications( false );
   inputCV.SetPosition( 7, 301 );
   inputCV.SetSize( 25, 25 );
   inputCV.SetSkin( "Jack Round Orange Ring" );

   outputAudio = new VoltageAudioJack( "Audio Output", "Audio Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputAudio );
   outputAudio.SetWantsMouseNotifications( false );
   outputAudio.SetPosition( 24, 101 );
   outputAudio.SetSize( 25, 25 );
   outputAudio.SetSkin( "Jack Round Cherry Ring" );

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Input" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 18, 33 );
   textLabel1.SetSize( 36, 22 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( false );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 12, false, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Output" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 18, 80 );
   textLabel2.SetSize( 36, 22 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( false );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 12, false, false );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "Freq" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 16, 200 );
   textLabel7.SetSize( 36, 22 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( false );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 12, false, false );

   textLabel8 = new VoltageLabel( "textLabel8", "textLabel8", this, "Ext CV" );
   AddComponent( textLabel8 );
   textLabel8.SetWantsMouseNotifications( false );
   textLabel8.SetPosition( 6, 279 );
   textLabel8.SetSize( 55, 22 );
   textLabel8.SetEditable( false, false );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel8.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel8.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel8.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel8.SetBorderSize( 1 );
   textLabel8.SetMultiLineEdit( false );
   textLabel8.SetIsNumberEditor( false );
   textLabel8.SetNumberEditorRange( 0, 100 );
   textLabel8.SetNumberEditorInterval( 1 );
   textLabel8.SetNumberEditorUsesMouseWheel( false );
   textLabel8.SetHasCustomTextHoverColor( false );
   textLabel8.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel8.SetFont( "Verdana", 12, false, false );

   textLabel16 = new VoltageLabel( "textLabel16", "textLabel16", this, "Dome Music Technologies" );
   AddComponent( textLabel16 );
   textLabel16.SetWantsMouseNotifications( false );
   textLabel16.SetPosition( 8, 341 );
   textLabel16.SetSize( 55, 19 );
   textLabel16.SetEditable( false, false );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel16.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel16.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel16.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel16.SetBorderSize( 1 );
   textLabel16.SetMultiLineEdit( true );
   textLabel16.SetIsNumberEditor( false );
   textLabel16.SetNumberEditorRange( 0, 100 );
   textLabel16.SetNumberEditorInterval( 1 );
   textLabel16.SetNumberEditorUsesMouseWheel( false );
   textLabel16.SetHasCustomTextHoverColor( false );
   textLabel16.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel16.SetFont( "Verdana", 7, false, false );

   switchMode = new VoltageSwitch( "Mode Switch", "Mode", this, 1 );
   AddComponent( switchMode );
   switchMode.SetWantsMouseNotifications( false );
   switchMode.SetPosition( 6, 138 );
   switchMode.SetSize( 16, 54 );
   switchMode.SetSkin( "4-State Slide Vertical" );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "U-Vibe" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 23, 176 );
   textLabel3.SetSize( 44, 15 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "Ph Low" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 23, 162 );
   textLabel4.SetSize( 44, 17 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 12, false, false );

   textLabel5 = new VoltageLabel( "textLabel5", "textLabel5", this, "Ph Med" );
   AddComponent( textLabel5 );
   textLabel5.SetWantsMouseNotifications( false );
   textLabel5.SetPosition( 23, 150 );
   textLabel5.SetSize( 42, 16 );
   textLabel5.SetEditable( false, false );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel5.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel5.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel5.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel5.SetBorderSize( 1 );
   textLabel5.SetMultiLineEdit( false );
   textLabel5.SetIsNumberEditor( false );
   textLabel5.SetNumberEditorRange( 0, 100 );
   textLabel5.SetNumberEditorInterval( 1 );
   textLabel5.SetNumberEditorUsesMouseWheel( false );
   textLabel5.SetHasCustomTextHoverColor( false );
   textLabel5.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetFont( "Verdana", 12, false, false );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "Ph High" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 23, 137 );
   textLabel6.SetSize( 47, 16 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( false );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 12, false, false );

   textLabel30 = new VoltageLabel( "textLabel30", "textLabel30", this, "Forth Phase" );
   AddComponent( textLabel30 );
   textLabel30.SetWantsMouseNotifications( false );
   textLabel30.SetPosition( 4, 0 );
   textLabel30.SetSize( 64, 31 );
   textLabel30.SetEditable( false, false );
   textLabel30.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel30.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel30.SetColor( new Color( 255, 212, 212, 255 ) );
   textLabel30.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel30.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel30.SetBorderSize( 1 );
   textLabel30.SetMultiLineEdit( true );
   textLabel30.SetIsNumberEditor( false );
   textLabel30.SetNumberEditorRange( 0, 100 );
   textLabel30.SetNumberEditorInterval( 1 );
   textLabel30.SetNumberEditorUsesMouseWheel( false );
   textLabel30.SetHasCustomTextHoverColor( false );
   textLabel30.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel30.SetFont( "Verdana", 14, false, false );

   knobDepth = new VoltageKnob( "CV Depth", "CV Depth", this, -2, 2, 0 );
   AddComponent( knobDepth );
   knobDepth.SetWantsMouseNotifications( false );
   knobDepth.SetPosition( 37, 300 );
   knobDepth.SetSize( 29, 29 );
   knobDepth.SetSkin( "Plastic Red" );
   knobDepth.SetRingSkin( "Crescent Offblack/White" );
   knobDepth.SetRange( -2, 2, 0, false, 0 );
   knobDepth.SetKnobParams( 215, 145 );
   knobDepth.DisplayValueInPercent( true );
   knobDepth.SetKnobAdjustsRing( false );

   knobFreq = new VoltageKnob( "Centre Freq", "Centre Freq", this, -5, 5, 0 );
   AddComponent( knobFreq );
   knobFreq.SetWantsMouseNotifications( false );
   knobFreq.SetPosition( 15, 221 );
   knobFreq.SetSize( 41, 41 );
   knobFreq.SetSkin( "Dial Red" );
   knobFreq.SetRange( -5, 5, 0, false, 0 );
   knobFreq.SetKnobParams( 215, 145 );
   knobFreq.DisplayValueInPercent( false );
   knobFreq.SetKnobAdjustsRing( true );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   CheckConnections();
   
   SetFeedback (switchMode.GetValue());
   SetFrequency (knobFreq.GetValue());
   
   previousFeedback = 0.0;
   
   stage1Capacitor = 0.0;
   stage2Capacitor = 0.0;
   stage3Capacitor = 0.0;
   stage4Capacitor = 0.0;

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == knobFreq)
         {
            SetFrequency (doubleValue);
         }
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
         if (component == switchMode)
         {
            SetFeedback (doubleValue);
         }
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
         CheckConnections();
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
         CheckConnections();
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here
   double drySignal;
   double wetSignal;
   double timeFactorRC;
   double resistorVoltage;
   double attenuatedCV;
   double finalOutputValue;
   double centreFreq;
   
   centreFreq = smoothFreq.GetSmoothValue();
   drySignal = inputAudio.GetValue();
   
   wetSignal = drySignal + (previousFeedback * smoothedFeedback);
   
   attenuatedCV = inputCV.GetValue() * knobDepth.GetValue() + centreFreq;
   
   if (attenuatedCV > 5.0)
   {
      attenuatedCV = 5.0;
   }
   else if (attenuatedCV < -5.0)
   {
      attenuatedCV = -5.0;
   }
   
   timeFactorRC = RC_FACTOR_MID + attenuatedCV * RC_FACTOR_MULT;      
   
   // Perform Stage 1 Allpass
   resistorVoltage = wetSignal - stage1Capacitor;
   stage1Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
   wetSignal = stage1Capacitor - resistorVoltage;
   
   // Perform Stage 2 Allpass
   resistorVoltage = wetSignal - stage2Capacitor;
   stage2Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
   wetSignal = stage2Capacitor - resistorVoltage;
   
   // Perform Stage 3 Allpass
   resistorVoltage = wetSignal - stage3Capacitor;
   stage3Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
   wetSignal = stage3Capacitor - resistorVoltage;

   // Perform Stage 4 Allpass
   resistorVoltage = wetSignal - stage4Capacitor;
   stage4Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
   wetSignal = stage4Capacitor - resistorVoltage;

   // Now perform output mixing   
   finalOutputValue = (wetSignal + drySignal) * 0.5;
      
   // Use mixed signal as feedback value for next iteration
   previousFeedback = finalOutputValue;                  
   
   if (BypassMix)
   {
      // Univibe Mode
      outputAudio.SetValue(wetSignal * gainCompensation);
   }
   else
   {
      // Phaser Mode
      outputAudio.SetValue(finalOutputValue * gainCompensation);
   }

   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public void ProcessBypassedSample()

//  ProcessBypassedSample gets called instead of ProcessSample when you've checked the "Can Be Bypassed" box
//  and a user has bypassed your module. If your module processes data from input jacks and then sends it to
//  output jack(s), make ProcessBypassedSample just send the data from the input jacks to the output jacks without
//  processing it.
//-------------------------------------------------------------------------------
@Override
public void ProcessBypassedSample()
{
   //[user-ProcessBypassedSample]   Add your own code here

   double temp;
   
   temp = smoothFreq.GetSmoothValue();
   
   temp = inputAudio.GetValue();
   
   outputAudio.SetValue(temp);
   
   stage1Capacitor = temp;            
   stage2Capacitor = temp;            
   stage3Capacitor = temp;            
   stage4Capacitor = temp; 
   
   previousFeedback = 0.0;             

   //[/user-ProcessBypassedSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageKnob knobFreq;
private VoltageKnob knobDepth;
private VoltageLabel textLabel30;
private VoltageLabel textLabel6;
private VoltageLabel textLabel5;
private VoltageLabel textLabel4;
private VoltageLabel textLabel3;
private VoltageSwitch switchMode;
private VoltageLabel textLabel16;
private VoltageLabel textLabel8;
private VoltageLabel textLabel7;
private VoltageLabel textLabel2;
private VoltageLabel textLabel1;
private VoltageAudioJack outputAudio;
private VoltageAudioJack inputCV;
private VoltageAudioJack inputAudio;


//[user-code-and-variables]    Add your own variables and functions here

// Constants

private final double RC_FACTOR_HIGH_FREQ = 0.725; // 5.5 kHz
private final double RC_FACTOR_LOW_FREQ  = 0.983; // 320 Hz
private final double RC_FACTOR_MULT  = (RC_FACTOR_HIGH_FREQ - RC_FACTOR_LOW_FREQ) * 0.1;
private final double RC_FACTOR_MID   = (RC_FACTOR_HIGH_FREQ + RC_FACTOR_LOW_FREQ) * 0.5;


private final double FEEDBACK_0 = 0.0;    // Univibe
private final double FEEDBACK_1 = 0.0;    // No Feedback
private final double FEEDBACK_2 = 0.8;    // Mid Feedback
private final double FEEDBACK_3 = 1.4;    // High Feedback

private final double ATTEN_0 = 1.0;    // Univibe
private final double ATTEN_1 = 0.85;   // No Feedback
private final double ATTEN_2 = 0.7;    // Mid Feedback
private final double ATTEN_3 = 0.6;    // High Feedback



// Variables

private double smoothedFeedback;
private double previousFeedback;
private double gainCompensation;

private double stage1Capacitor;
private double stage2Capacitor;
private double stage3Capacitor;
private double stage4Capacitor;

private boolean CVinConnected;
private boolean InputConnected;
private boolean OutputConnected;
private boolean BypassMix;

// Objects

private SmoothValue smoothFreq = new SmoothValue();


private void CheckConnections()
{
   CVinConnected = inputCV.IsConnected();
   InputConnected = inputAudio.IsConnected();
   OutputConnected = outputAudio.IsConnected();   
}

private void SetFeedback(double feedback)
{
   if (feedback < 0.5)
   {
      // OFF
      BypassMix = true;
      smoothedFeedback = FEEDBACK_0;
      gainCompensation = ATTEN_0;
   }
   else if (feedback < 1.5)
   {
      // LOW
      BypassMix = false;
      smoothedFeedback = FEEDBACK_1;
      gainCompensation = ATTEN_1;
   }
   else if (feedback < 2.5)
   {
      // MED
      BypassMix = false;
      smoothedFeedback = FEEDBACK_2;
      gainCompensation = ATTEN_2;
   }
   else
   {
      // HIGH
      BypassMix = false;
      smoothedFeedback = FEEDBACK_3;
      gainCompensation = ATTEN_3;
   }
}

private void SetFrequency(double freq)
{
   smoothFreq.SetValue(freq);
}

//[/user-code-and-variables]
}

 